#
# Conditional build:
%bcond_without	python2	# CPython 2.x module
%bcond_without	python3	# CPython 3.x module
%bcond_without	tests	# unit tests

# TODO: tests hang on x32
%ifarch x32
%undefine with_tests
%endif

%define		module  sqlalchemy
Summary:	Database Abstraction Library for Python 2
Summary(pl.UTF-8):	Biblioteka abstrakcji baz danych dla Pythona 2
Name:		python-%{module}
# keep 1.x here for python2 support
Version:	1.4.54
Release:	1
License:	MIT
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/sqlalchemy/
Source0:	https://files.pythonhosted.org/packages/source/s/sqlalchemy/sqlalchemy-%{version}.tar.gz
# Source0-md5:	8f156a25d7ad78a62eebd3da6de1442d
Patch0:		%{name}-tests.patch
Patch1:		pep263.patch
URL:		https://www.sqlalchemy.org/
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with python2}
BuildRequires:	python-devel >= 1:2.7
BuildRequires:	python-modules >= 1:2.7
BuildRequires:	python-setuptools >= 0.6-0.a9.1
%if %{with tests}
BuildRequires:	python-mock
BuildRequires:	python-pytest >= 4.6.11
BuildRequires:	python-pytest-xdist
%endif
%endif
%if %{with python3}
BuildRequires:	python3-devel >= 1:3.4
BuildRequires:	python3-modules >= 1:3.4
BuildRequires:	python3-setuptools >= 0.6-0.a9.1
%if %{with tests}
BuildRequires:	python3-pytest >= 6.2
BuildRequires:	python3-pytest-xdist
%endif
%endif
Requires:	python-modules
Provides:	python-SQLAlchemy = %{version}-%{release}
Obsoletes:	python-SQLAlchemy < 0.9.8
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The Python SQL toolkit and Object Relational Mapper that gives
application developers the full power and flexibility of SQL.
SQLAlchemy provides a full suite of well known enterprise-level
persistence patterns, designed for efficient and high-performing
database access, adapted into a simple and Pythonic domain language.

Python 2.x version.

%description -l pl.UTF-8
Zestaw narzędzi SQL oraz odwzorowań obiektowo-relacyjnych dla Pythona,
dający programistom całą potęgę i elastyczność SQL-a. SQLAlchemy
udostępnia pełny zbiór dobrze znanych wzorców trwałości,
zaprojektowanych z myślą o efektywny i wydajnym dostępem do baz
danych, zaadaptowanych do prostego, pythonowego języka.

Wersja dla pythona 2.x.

%package -n python3-%{module}
Summary:	Database Abstraction Library for Python 3
Summary(pl.UTF-8):	Biblioteka abstrakcji baz danych dla Pythona 3
Group:		Libraries/Python
Provides:	python3-SQLAlchemy = %{version}-%{release}
Obsoletes:	python3-SQLAlchemy < 0.9.8

%description -n python3-%{module}
The Python SQL toolkit and Object Relational Mapper that gives
application developers the full power and flexibility of SQL.
SQLAlchemy provides a full suite of well known enterprise-level
persistence patterns, designed for efficient and high-performing
database access, adapted into a simple and Pythonic domain language.

Python 3.x version.

%description -n python3-%{module} -l pl.UTF-8
Zestaw narzędzi SQL oraz odwzorowań obiektowo-relacyjnych dla Pythona,
dający programistom całą potęgę i elastyczność SQL-a. SQLAlchemy
udostępnia pełny zbiór dobrze znanych wzorców trwałości,
zaprojektowanych z myślą o efektywny i wydajnym dostępem do baz
danych, zaadaptowanych do prostego, pythonowego języka.

Wersja dla Pythona 3.x.

%package apidocs
Summary:	API documentation for Python SQLAlchemy module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona SQLAlchemy
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for Python SQLAlchemy module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona SQLAlchemy.

%package examples
Summary:	Examples for Python SQLAlchemy module
Summary(pl.UTF-8):	Przykłady do modułu Pythona SQLAlchemy
Group:		Documentation
BuildArch:	noarch

%description examples
Examples for Python SQLAlchemy module.

%description examples -l pl.UTF-8
Przykłady do modułu Pythona SQLAlchemy.

%prep
%setup -q -n sqlalchemy-%{version}
%patch -P 0 -p1
%patch -P 1 -p1

%build
%if %{with python2}
%py_build

%if %{with tests}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTHONPATH=$(echo $(pwd)/build-2/lib.linux-*) \
LANG=C.UTF-8 \
%{__python} -m pytest test -k 'not test_fixture_five'
# in OverlappingFksSiblingTest.test_fixture_five[False] reported warnings differ from reference
%endif
%endif

%if %{with python3}
%py3_build

%if %{with tests}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTHONPATH=$(echo $(pwd)/build-3/lib.linux-*) \
%{__python3} -m pytest test
%endif
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install

%py_postclean
%endif

%if %{with python3}
%py3_install
%endif

install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
cp -pr examples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc AUTHORS CHANGES LICENSE README.rst
%dir %{py_sitedir}/sqlalchemy
%{py_sitedir}/sqlalchemy/connectors
%{py_sitedir}/sqlalchemy/databases
%{py_sitedir}/sqlalchemy/dialects
%{py_sitedir}/sqlalchemy/engine
%{py_sitedir}/sqlalchemy/event
%{py_sitedir}/sqlalchemy/ext
%{py_sitedir}/sqlalchemy/future
%{py_sitedir}/sqlalchemy/orm
%{py_sitedir}/sqlalchemy/pool
%{py_sitedir}/sqlalchemy/sql
%{py_sitedir}/sqlalchemy/testing
%{py_sitedir}/sqlalchemy/util
%attr(755,root,root) %{py_sitedir}/sqlalchemy/cimmutabledict.so
%attr(755,root,root) %{py_sitedir}/sqlalchemy/cprocessors.so
%attr(755,root,root) %{py_sitedir}/sqlalchemy/cresultproxy.so
%{py_sitedir}/sqlalchemy/*.py[co]
%{py_sitedir}/SQLAlchemy-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-%{module}
%defattr(644,root,root,755)
%doc AUTHORS CHANGES LICENSE README.rst
%dir %{py3_sitedir}/sqlalchemy
%{py3_sitedir}/sqlalchemy/connectors
%{py3_sitedir}/sqlalchemy/databases
%{py3_sitedir}/sqlalchemy/dialects
%{py3_sitedir}/sqlalchemy/engine
%{py3_sitedir}/sqlalchemy/event
%{py3_sitedir}/sqlalchemy/ext
%{py3_sitedir}/sqlalchemy/future
%{py3_sitedir}/sqlalchemy/orm
%{py3_sitedir}/sqlalchemy/pool
%{py3_sitedir}/sqlalchemy/sql
%{py3_sitedir}/sqlalchemy/testing
%{py3_sitedir}/sqlalchemy/util
%attr(755,root,root) %{py3_sitedir}/sqlalchemy/cimmutabledict.cpython-*.so
%attr(755,root,root) %{py3_sitedir}/sqlalchemy/cprocessors.cpython-*.so
%attr(755,root,root) %{py3_sitedir}/sqlalchemy/cresultproxy.cpython-*.so
%{py3_sitedir}/sqlalchemy/*.py
%{py3_sitedir}/sqlalchemy/__pycache__
%{py3_sitedir}/SQLAlchemy-%{version}-py*.egg-info
%endif

%files apidocs
%defattr(644,root,root,755)
%doc doc/{_images,_modules,_static,changelog,core,dialects,faq,orm,*.html,*.js}

%files examples
%defattr(644,root,root,755)
%{_examplesdir}/%{name}-%{version}
%changelog
* Thu Mar 27 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-sqlalchemy.git;a=log;h=master

* Thu Mar 27 2025 Jan Palus <atler@pld-linux.org> bc89eeb
- correct file encoding declaration

* Tue Mar 25 2025 Jan Palus <atler@pld-linux.org> 2cf78b4
- up to 1.4.54

* Tue Mar 25 2025 Jan Palus <atler@pld-linux.org> 5edbdd6
- fix files when building without python2

* Wed Mar 12 2025 Jan Rękorajski <baggins@pld-linux.org> e7c4bc1
- disable tests on x32, rel 4

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 54e9f1c
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> cf2dac1
- python 3.13 rebuild

* Sun Mar 09 2025 Jan Rękorajski <baggins@pld-linux.org> d927657
- use patch -P

* Tue Dec 26 2023 Jakub Bogusz <qboosh@pld-linux.org> 9ead9e0
- updated to 1.4.50

* Thu Dec 22 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> 852d765
- Up to 1.4.45

* Wed Dec 21 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> 3168f47
- Up to 1.4.40

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 2899a1b
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 95c4554
- rebuild with python 3.10

* Sun Nov 28 2021 Jan Rękorajski <baggins@pld-linux.org> cbac615
- do not test azure connection, rel 5

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> 90203ae
- rebuild with separate debuginfo build-ids

* Sun Mar 07 2021 Jan Rękorajski <baggins@pld-linux.org> 3bbbe70
- release 3 (by relup.sh)

* Sun Mar 07 2021 Jan Rękorajski <baggins@pld-linux.org> c29bd22
- rediff patches

* Sun Mar 07 2021 Jan Rękorajski <baggins@pld-linux.org> 64cef89
- release 2 (by relup.sh)

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> 6577ab4
- unconditional noarch subpackages

* Sat Feb 06 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> b148bdf
- up to 1.3.23

* Mon Jan 18 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 57c38b9
- up to 1.3.22

